function OrientationManager(navigatorCore) {

	this.navigatorCore = navigatorCore;
	this.rotationCentre = [0, 0];
	this.lastKnownRotation = 0;
	this.lastKnownRotationDeg = 0;

	
	this.setAutoRotateMap = function (flag) {
		// orientation
		this.autoRotateMap = flag;
		if (!this.deviceOrientationListener) {
				this.initDeviceOrientationListener();
			}
		if (this.autoRotateMap) {
			this.startAutoRotateMap();
		} else {
			this.startAutoRotateUserIcon();
		}
	}

	this.setRotationCentre = function (centre) {
		this.rotationCentre = centre;
	}
	this.getLastKnownRotationDeg = function (centre) {
		return this.lastKnownRotationDeg;
	}

	this.getLastKnownRotation = function (centre) {
		return this.lastKnownRotation;
	}

	this.startAutoRotateUserIcon = function () {
		if (this.iconRotationHandler) {
			ol.Observable.unByKey(this.iconRotationHandler);
			this.iconRotationHandler = undefined;
		}
		if (this.mapRotationHandler) {
			ol.Observable.unByKey(this.mapRotationHandler);
			this.mapRotationHandler = undefined
		}

		//var startRotation = - this.getOrientationOffset();
		//map.getView().rotate(0, this.rotationCentre);
		function callback(complete) {
			if (!complete) {
				map.getView().rotate(0, this.rotationCentre);
			}
		}
		var om = navigatorCore.orientationManager;
		/*
		map.getView().animate({
			rotation: 0,
			anchor: this.rotationCentre,
			duration: 500,
		}, callback);
		om.rotateCompass(0);
		*/
		om.startMapRotation = map.getView().getRotation();
		
		if (om.getLastKnownRotation()){
			navigatorCore.userLocationDisplay.updateUserIconRotation(om.getLastKnownRotation()+om.startMapRotation);
			om.lastKnownRotationDeg = om.getLastKnownRotation() * (180 / Math.PI);
			om.rotateCompass(-om.lastKnownRotationDeg);
		}

		this.iconRotationHandler = this.deviceOrientationListener.on('change', function () {

				var newRotation = om.getCompassHeading(om.deviceOrientationListener) + om.getOrientationOffset();

				if (Math.abs(om.getLastKnownRotation() - newRotation) > Math.PI / 30) {

					//	alert('deviceOrientationChanged');
					navigatorCore.userLocationDisplay.updateUserIconRotation(newRotation+om.startMapRotation);
					om.lastKnownRotation = om.getCompassHeading(om.deviceOrientationListener) + om.getOrientationOffset();
					om.lastKnownRotationDeg = om.lastKnownRotation * (180 / Math.PI);
					navigatorCore.deviceOrientationChanged(om.lastKnownRotationDeg);
				}
			});

	}

this.startAutoRotateMap = function () {
	this.firstRoatation = true;

	if (this.iconRotationHandler) {
		ol.Observable.unByKey(this.iconRotationHandler);
		this.iconRotationHandler = undefined;
	}
	if (this.mapRotationHandler) {
		ol.Observable.unByKey(this.mapRotationHandler);
		this.mapRotationHandler = undefined
	}
	this.animating = false;


	this.navigatorCore.userLocationDisplay.resetUserIconRotation();
	this.mapRotationHandler = this.deviceOrientationListener.on('change', function () {

			var currentRotation = map.getView().getRotation();
			var om = navigatorCore.orientationManager;
			if (debugConsoleEnabled) {
			//	document.getElementById('alpha').innerText = om.deviceOrientationListener.getAlpha();
			//	document.getElementById('beta').innerText = om.deviceOrientationListener.getBeta();
				//document.getElementById('gamma').innerText = om.deviceOrientationListener.getGamma();
				//document.getElementById('heading').innerText = om.getCompassHeading(om.deviceOrientationListener);

			}
			var newRotation =  - om.getCompassHeading(om.deviceOrientationListener) - om.getOrientationOffset();
			function callback(complete) {
					om.animating = false;
					if(!complete){
					  map.getView().rotate(newRotation, om.rotationCentre);
					}
				}
			if (!om.animating && om.firstRoatation && newRotation) {
				om.firstRoatation = false;
				om.animating = true;
				map.getView().animate({
					rotation: newRotation,
					anchor: om.rotationCentre,
					duration: 500,
				}, callback);
			}

			if (!om.animating && Math.abs(currentRotation - newRotation) > Math.PI / 20) {
				map.getView().rotate(newRotation, om.rotationCentre);

				/*
				if (!isAndroid()) {
				map.getView().animate({
				rotation: newRotation,
				anchor: om.rotationCentre,
				duration: 100,
				});
				} else {
				map.getView().animate({
				rotation: newRotation,
				anchor: om.rotationCentre,
				duration: 10,
				});
				}
				 */
				om.lastKnownRotation = om.getCompassHeading(om.deviceOrientationListener) + om.getOrientationOffset();
				om.lastKnownRotationDeg = om.lastKnownRotation * (180 / Math.PI);
				navigatorCore.deviceOrientationChanged(om.lastKnownRotationDeg);
				om.rotateCompass(-om.lastKnownRotationDeg);

			}

		});

}
	this.getCompassHeading = function (deviceOrientationListener) {

		if (isAndroid()) {
			// chrome on Android
			return 2 * Math.PI - deviceOrientationListener.getAlpha();
		} else {
			return deviceOrientationListener.getHeading();
		}

	}

	this.getRotation = function () {
		return newRotation =  - this.deviceOrientationListener.getHeading() - getOrientationOffset();
	}

	this.initDeviceOrientationListener = function () {
		this.deviceOrientationListener = new ol.DeviceOrientation();
		this.deviceOrientationListener.setTracking(true);
	}

	this.getOrientationOffset = function () {
		//return 0;
		var offset = 0;

		switch (window.orientation) {
		case 0:
			break;

		case -90:
			offset = -Math.PI / 2;
			break;

		case 90:
			offset = Math.PI / 2;
			break;

		case 180:
			offset = -Math.PI;
			break;
		}
	if (!isAndroid())return offset +  (Math.PI/180)*mapViewerOptions.magnaticPoleOffset;
	else return offset + (Math.PI/180)*mapViewerOptions.magnaticPoleOffsetAndroid;
	}

	this.rotateCompass = function (roatationDeg) {
		var compass = $("#compass_display");

		$(compass).css({
			"-webkit-transform" : "rotate(" + roatationDeg + "deg)",
			"-moz-transform" : "rotate(" + roatationDeg + "deg)",
			"transform" : "rotate(" + roatationDeg + "deg)",

		});

	}

}